from turtle import *
from math import *

def hexa(longueur):
    """
    Trace un hexagone régulier de côté longueur,
    à partir de l'endroit où est la tortue.
    """
    down()
    for i in range(6):
        forward(longueur)
        left(60)
    up()

def sixDoublesHexa(x,y):
    """
    Trace 6 doubles hexagones autour du centre
    de l'étoile, dont les coordonnées sont (x;y).
    """
    up()
    # Regarde vers la droite.
    setheading(0)
    goto(x+20,y)
    right(60)
    # On commence par tracer le petit hexagone de droite.
    hexa(45)
    for i in range(5) :
        # Puis on trace les 5 autres petits.
        left(180)
        forward(20)
        right(120)
        hexa(45)

    setheading(0)
    goto(x+15,y)
    right(60)
    # On trace ensuite le grand hexagone de droite.
    hexa(50)
    for i in range(5) :
        # Puis on trace les 5 autres grands.
        left(180)
        forward(15)
        right(120)
        hexa(50)
    up()

# Pour tracer plus vite.   
speed(0)
x=2*(sqrt(1.5**2-.75**2)+sqrt(5**2-2.5**2))*cos(pi/6)*10
y=2*(sqrt(1.5**2-.75**2)+sqrt(5**2-2.5**2))*sin(pi/6)*10

sixDoublesHexa(0,0)

sixDoublesHexa(x,y)
sixDoublesHexa(x,-y)
sixDoublesHexa(-x,y)
sixDoublesHexa(-x,-y)

sixDoublesHexa(2*x,0)
sixDoublesHexa(-2*x,0)
sixDoublesHexa(0,2*y)
sixDoublesHexa(0,-2*y)

sixDoublesHexa(2*x,2*y)
sixDoublesHexa(-2*x,2*y)
sixDoublesHexa(2*x,-2*y)
sixDoublesHexa(-2*x,-2*y)

sixDoublesHexa(x,3*y)
sixDoublesHexa(-x,3*y)
sixDoublesHexa(x,-3*y)
sixDoublesHexa(-x,-3*y)

# Et on peut continuer ...
